<template>
  <main>
    <ul id="overview">
      <li><a href="#overview">Overview</a></li>
      <li><a href="#issues">Issue list</a></li>
    </ul>
    <sus-stats
      :issues="issues"
      :target="target"
      :coordination-issue="data.coordinationIssue"
    ></sus-stats>
    <section v-if="issues.length">
      <h2 id="issues" class="fullwidth">Issues</h2>
      <stats-table :data="issues" :header-config="issueHeaderConfig">
        <template v-slot:row="{ entry }">
          <td>
            {{ entry.trackedInPlanningIssue ? "Tracked" : "Not tracked" }}
          </td>
          <td>{{ entry.issueStatus }}</td>
          <td>
            <a :href="`https://gitlab.com${entry.webPath}`"
              ><span v-html="entry.titleHtml" /></a
            ><br />
            <span v-if="entry.assignees.length" style="display: inline-block">
              Assignees:
              <person
                v-for="handle in entry.assignees"
                :handle="handle"
                style="margin: 0 0.25rem"
              />&nbsp;
            </span>
            <template v-else> Unassigned </template>
          </td>
          <td>
            <Milestone v-if="entry.milestone" :milestone="entry.milestone" />
          </td>
          <td>
            {{ entry.groups.join(" ") }}
          </td>
          <td>{{ entry.labels }}</td>
        </template>
      </stats-table>
    </section>
  </main>
</template>
<script>
import SusStats from "./components/SUSStats.vue";
import StatsTable from "./components/StatsTable.vue";
import Value from "./components/Value.vue";
import OverallStats from "./components/OverallStats.vue";
import Person from "./components/Person.vue";
import Milestone from "./components/Milestone.vue";
import { enhanceSUSIssues } from "../lib/analysis";
import {
  FILTER_ANY,
  FILTER_EMPTY_ARRAY,
  FILTER_MULTI_SELECT,
  FILTER_TEXT_SEARCH,
} from "../lib/constants";

export default {
  components: { Milestone, Person, OverallStats, Value, StatsTable, SusStats },
  data() {
    return {
      data: {},
      showTeamMembers: true,
    };
  },
  props: {
    statsPromise: {
      type: Promise,
    },
  },
  async mounted() {
    this.data = await this.statsPromise;
    await this.$nextTick();
    const { hash } = window.location;
    const el = hash && document.querySelector(hash);
    if (el) {
      el.scrollIntoView();
    }
  },
  computed: {
    issueHeaderConfig() {
      return [
        {
          field: "trackedInPlanningIssue",
          text: "Tracked in issue",
          sortable: true,
          filterType: FILTER_MULTI_SELECT,
          filter: [
            { name: "Any ", value: FILTER_ANY },
            { name: "Tracked", value: true },
            { name: "Not tracked", value: false },
          ],
        },
        {
          field: "issueStatus",
          text: "Status",
          sortable: true,
          filterType: FILTER_MULTI_SELECT,
          defaultSort: true,
          filter: [
            { name: "Any status (Reset)", value: FILTER_ANY },
            ...[...new Set(this.issues.flatMap((i) => i.issueStatus))]
              .sort()
              .map((x) => ({ name: x, value: x })),
          ],
        },
        {
          field: "iid",
          text: "Link",
          sortable: false,
        },
        {
          field: "milestone",
          text: "Milestone",
          sortable: true,
        },
        {
          field: "groups",
          text: "Groups",
          sortable: true,
          filterType: FILTER_MULTI_SELECT,
          filter: [
            { name: "Any group", value: FILTER_ANY },
            { name: "No group", value: FILTER_EMPTY_ARRAY },
            ...[...new Set(this.issues.flatMap((i) => i.groups))]
              .sort()
              .map((x) => ({ name: x, value: x })),
          ],
        },
        {
          field: "labels",
          text: "Labels",
          filterType: FILTER_TEXT_SEARCH,
          sortable: false,
        },
      ];
    },
    issues() {
      const issues = (Object.freeze(this.data.issues) || []).filter(
        (x) => !x.closedAt || x.closedAt > "2022-05-01T00:00:00Z"
      );

      return enhanceSUSIssues(issues);
    },
    target() {
      return this.data.target;
    },
    closedIssues() {
      return this.data.issues.filter((x) => !!x.closedAt).length;
    },
  },
};
</script>
